package sugr.GUI;
import javax.swing.table.TableCellRenderer;
import javax.swing.JTable;
import java.awt.Component;
import javax.swing.JLabel;
import javax.swing.border.Border;
import java.awt.Color;
import javax.swing.BorderFactory;

/** Needed for table in Entity, so that the background-color is intuitive
 * @author Norbert Fischer
 * @version 1.0 - Date: 01.02.03
 *  	<p> Was taken from ConstructionApplet.java because of RelationApplet.java: 
 *  	    Otherwise, it would be defined two times.
 * 		</p>
 */
public class GrayBackgroundTableCellRenderer implements TableCellRenderer
{
	public Component getTableCellRendererComponent(
		JTable table,
		Object value,
		boolean isSelected,
		boolean hasFocus,
		int row,
		int column)
	{
		//Label erzeugen
		JLabel label = new JLabel((String) value);
		label.setOpaque(true);
		Border b = BorderFactory.createEmptyBorder(1, 1, 1, 1);
		label.setBorder(b);
		label.setFont(table.getFont());
		label.setForeground(table.getForeground());
		//Color is Background-Color from panel		
		if (row > column)
			label.setBackground(new Color(204, 204, 204));
		else
			label.setBackground(Color.white);
		if (hasFocus)
		{
			label.setBackground(Color.blue);
			label.setForeground(Color.white);
		}
		return label;
	}
}
