/** Java class "Orthogonal.java" generated from Poseidon for UML. 
 *  Poseidon for UML is developed by <A HREF="http://www.gentleware.com">Gentleware</A>.
 *  Generated with <A HREF="http://jakarta.apache.org/velocity/">velocity</A> template engine.
 */
package sugr;

import sugr.linalg.*;

/**
 * Contains methods if two elements are orthogonal or not. You can retrieve then a lot 
 * of information about this test, for example: chi-value used, 
 * the testvalue and so on.
 * 
 * @author Norbert Fischer
 * @version 
 * <b> 1.1 (12.2.2003) </b> <br> 
 * 		Fixed: compute_distance -> Line_3D/Plane_3D 
 * 			Covariance-calculation changed from a.getCov() to 
 * 			a.getJacobeanHomogeneousPart(). Analog l <br>
 * 
 * <b> 1.2 (20.2.2003) </b> <br>
 * 		Fixed: computation of error propagation (ep) was wrong everywhere
 * 			(except Line_3D/Plane_3D). ep needs also the homogeneous parts
 * 			of the elements - just adding covariances is not enough ;-) <br>
 * 
 * <b> 1.2.1 (24.2.2003) </b> <br>
 * 		Changed: works now on copies of entities. This preserves the 
 * 			original input values from changing!!!
 * <b> 2.0 (June 2003)</b> <br>
 * 		Is now derived from BiRelationalProperty !!!
 * 
 */
public class Orthogonal extends BiRelationalProperty {

	///////////////////////////////////////
	// operations

	/**
	 * <p>
	 * Return Jacobian Matrix A of the first Entity and the relation type.
	 * </p><p>
	 * 
	 * @return Jacobian Matrix A
	 * </p>
	 */
	public Matrix getJacobian() {
		return first.getJacobianOfRelation(Orthogonal.class, secondEntityType);
	}
	/**
	 * <p>
	 * Compute degrees of freedom of that Relation
	 * </p><p>
	 * 
	 * @return degrees of freedom of that Relation
	 * </p>
	 */
	public int getDof() {
		return first.getDofOfRelation(Orthogonal.class, secondEntityType);
	}

	/**
	 * Build up an Orthogonal-Relation between two Line_2D.
	 * @param l  first Line_2D
	 * @param secondClass could be a Line_2D
	 */
	public Orthogonal(Line_2D l, Class secondClass) {
		super(l, secondClass);
	} // end Orthogonal        

	/**
	 * Build up an Orthogonal-Relation between two Line_3D.
	 * @param l  first Line_3D
	 * @param secondClass could be a Line_3D or Plane_3D
	 */
	public Orthogonal(Line_3D l, Class secondClass) {
		super(l, secondClass);
	} // end Orthogonal        

	/**
	 * Build up an Orthogonal-Relation between two Plane_3D.
	 * @param a  first Plane_3D
	 * @param secondClass could be a Plane_3D or Line_3D
	 */
	public Orthogonal(Plane_3D a, Class secondClass) {
		super(a, secondClass);
	} // end Orthogonal        

	/** <p>
	 * Returns the Covariance Matrix of the row-vector of the Jacobian Matrix A of the first Entity and the relation type.
	 * </p>
	 *
	 * @param row Row vector, for which the Covariance matrix is to be returned
	 * @return covariance of the row vector of the jacobian
	 */
	public Matrix getCovarianceOfJacobianRow(int row) {
		return first.getCovarianceOfJacobianRowOfRelation(
			Orthogonal.class,
			secondEntityType,
			row);
	}

} // end Orthogonal
