/*
 * Created on 10.05.2004
 *
 */
package sugr.test;

import sugr.*;
import sugr.linalg.*;
import junit.framework.TestCase;

/**
 * @author Bastian Oehler
 *
 */
public class TransformationTest extends TestCase {

	/**
	 * Constructor for TransformationTest.
	 * @param arg0
	 */
	public TransformationTest(String arg0) {
		super(arg0);
	}

	/**
	 * Test for int getDimension()
	 */
	public void testGetDimension() {
		Affinity_2D aff2d = new Affinity_2D();
		int dim = aff2d.getDimension();
		if (dim!=9)fail();
		Affinity_3D aff3d = new Affinity_3D();
		dim = aff3d.getDimension();
		if (dim!=16)fail();
	}

	/**
	 * Test for Matrix getTransformationMatrix
	 */
	public void testGetTransformationMatrix() {
		Affinity_2D aff = new Affinity_2D(3,9,4,6,7,1);
		double[][] matArray = {{3,4,7},{9,6,1},{0,0,1}};
		Matrix matCalc = LinearAlgebraFactory.getMatrix(matArray);
		Matrix matSugr = aff.getTransformationMatrix();
		for(int i=0;i<3;i++)
			for(int j=0;j<3;j++)
				if(matCalc.get(i,j)!=matSugr.get(i,j))fail();
	}
}
